% Reverberation control panel
%
% Zheng Hua, 11/98

clc;
disp(' ');
disp(' Clearing all windows to begin the Reverberation Control Panel');
disp(' Now loading ...');
disp(' ');
disp(' ');
close all;

%========================================
% Initialize important default values and parameter limits

defaultPos=get(0,'DefaultFigurePosition');
defaultPos(1:4)=[10 50 750 500];	%x0 y0 width height
set(0,'DefaultFigurePosition',defaultPos);

%========================================
% main window

figNumber=figure( ...
	'NumberTitle','off', ...
	'Name','Reverberation Control Panel', ...
   'Resize','off', ...
   'color','black', ...
	'Pointer','watch');
%set(gca,'position',[0 0 1 1]);	%gca: grab current axis
%axis off
%axHndl1=gca;
%axHndl2=axes( ...
%   'Units','pixels', ...
%    'Position',[136 183 100 100], ...
%    'Visible','off');

%========================================
% Create buttons

quitButton=uicontrol( ...
    'Style','pushbutton', ...
    'Units','normalized', ...
    'Position',[.05,.03,.25,.06], ...
    'String','Quit', ...
    'Enable','on', ...
	'Callback','close all;');

sendButton=uicontrol( ...
    'Style','pushbutton', ...
    'Units','normalized', ...
    'Position',[.7,.03,.25,.06], ...	%[x0 y0 width height], ...
    'String','Send parameters to port', ...
    'Enable','off',...
	'Callback','dataio(''send'');');

openButton=uicontrol( ...
    'Style','pushbutton', ...
    'Units','normalized', ...
    'Position',[.05,.13,.25,.06], ...	%[x0 y0 width height], ...
    'String','Get parameters from file', ...
    'Enable','on',...
	'Callback','dataio(''open'');');

saveButton=uicontrol( ...
    'Style','pushbutton', ...
    'Units','normalized', ...
    'Position',[.7,.13,.25,.06], ...	%[x0 y0 width height], ...
    'String','Save parameters to file', ...
    'Enable','on',...
	'Callback','dataio(''save'');');

global filenameBox filename; filename = 'default.rev';
filenameBox=uicontrol('Style','edit', ...
        'Units','normalized', ...
	'Position',[.37 .13 .25 .06],...
	'String',filename, ...
	'Callback','dataio(''setfile'');');

%========================================
% Global variables


global ENum EDel ECoe EDelSlider ECoeSlider EDelVal ECoeVal;
global EDelMax EDelMin ECoeMax ECoeMin;
ENum = 3; EDelMax = 85; EDelMin = 0.1; ECoeMax = 1; ECoeMin = 0;
EDel(1:ENum) = [20 38.9 69.9];
ECoe(1:ENum) = [.88 .635 .267];

global CNum CTim CDam CDel CCoeL CCoeH CCoeC CCoeD;
global CTimSlider CTimVal CDamSlider CDamVal CDelSlider CDelVal;
global CCoeLBox CCoeHBox;
global CDelMax CDelMin CTimMax CTimMin CDamMax CDamMin;
CNum = 6;
CDelMax = 85; CDelMin = 0.1;
CTimMax = 20; CTimMin = 0.1;
CDamMax = 50; CDamMin = 1;
CTim = 5; CDam = 10;
CDel(1:CNum) = [50 56 61 68 72 78];

global ANum ADel ADelMax ADelMin;
global ADelSlider ADelVal;
ANum = 3; ADelMax = 10; ADelMin = 0.1;
ADel(1:ANum) = [6 1.7 .63];

global RMix RMixSlider RMixVal RMixMax RMixMin;
global RBri RBriSlider RBriVal RBriMax RBriMin;
RMixMax = 1; RMixMin = 0;
RBriMax = 1; RBriMin = 0;
RBri = .2; RMix = .4;

updateer('start',0);
updateco('start',0);
updateap('start',0);
updatebm('start',0);

set(gcf,'Pointer','arrow');
set(sendButton,'Enable','on');

