function dataio(action);
%=======================================
% send data to file/port, open data file

global ENum EDel ECoe EDelSlider ECoeSlider EDelVal ECoeVal;
global CNum CTim CDam CDel CCoeL CCoeH CCoeC CCoeD;
global CTimSlider CTimVal CDamSlider CDamVal CDelSlider CDelVal;
global CCoeLBox CCoeHBox CCoeCBox CCoeDBox;
global ANum ADel;
global ADelSlider ADelVal;
global RMix RMixSlider RMixVal;
global RBri RBriSlider RBriVal;
global filenameBox filename;
global EDelMax CDelMax ADelMax;

if strcmp(action,'setfile')
	filename = get(filenameBox,'string');

elseif strcmp(action,'save')

	fid = fopen(filename,'w');
	if (fid < 2)
		dialog('style','error',...
			'name','File error',...
			'TextString',['Error opening ' filename ' !']);
		return
	end

	for i = 1:ENum
		fprintf(fid,'%f\t%f\n',EDel(i),ECoe(i));
	end
	for i = 1:CNum
		fprintf(fid,'%f\t%f\t%f\n',CDel(i),CCoeL(i),CCoeH(i));
	end
	for i = 1:ANum
		fprintf(fid,'%f\n',ADel(i));
	end
	fprintf(fid,'%f\t%f\t%f\t%f\n',CTim,CDam,RBri,RMix);

	fclose(fid);

elseif strcmp(action,'open')
	fid = fopen(filename,'r');
	if (fid < 2)
		dialog('style','error',...
			'name','File error',...
			'TextString',['Error opening ' filename ' !']);
		return
	end
	for i = 1:ENum
		EDel(i) = fscanf(fid,'%f',1);
		set(EDelSlider(i),'value',EDel(i));
		set(EDelVal(i),'string',num2str(EDel(i)));
		ECoe(i) = fscanf(fid,'%f',1);
		set(ECoeSlider(i),'value',ECoe(i));
		set(ECoeVal(i),'string',num2str(ECoe(i)));
	end
	for i = 1:CNum
		CDel(i) = fscanf(fid,'%f',1);
		set(CDelSlider(i),'value',CDel(i));
		set(CDelVal(i),'string',num2str(CDel(i)));
		CCoeL(i) = fscanf(fid,'%f',1);
		set(CCoeLBox(i),'string',num2str(CCoeL(i)));
		CCoeH(i) = fscanf(fid,'%f',1);
		set(CCoeHBox(i),'string',num2str(CCoeH(i)));
		CCoeD(i) = (CCoeL(i) - CCoeH(i)) / (CCoeL(i) + CCoeH(i));
      CCoeC(i) = (1. - CCoeD(i) ) * CCoeL(i);
		set(CCoeCBox(i),'string',num2str(CCoeC(i)));
		set(CCoeDBox(i),'string',num2str(CCoeD(i)));
	end
	for i = 1:ANum
		ADel(i) = fscanf(fid,'%f',1);
		set(ADelSlider(i),'value',ADel(i));
		set(ADelVal(i),'string',num2str(ADel(i)));
	end
	CTim = fscanf(fid,'%f',1);
	set(CTimSlider,'value',CTim);
	set(CTimVal,'string',num2str(CTim));
	CDam = fscanf(fid,'%f',1);
	set(CDamSlider,'value',CDam);
	set(CDamVal,'string',num2str(CDam));
	RBri = fscanf(fid,'%f',1);
	set(RBriSlider,'value',RBri);
	set(RBriVal,'string',num2str(RBri));
	RMix = fscanf(fid,'%f',1);
	set(RMixSlider,'value',RMix);
	set(RMixVal,'string',num2str(RMix));

	fclose(fid);

elseif strcmp(action,'send')
   
   scale = 254;       % for maximum value

   EDelScale = 256/4096;	%85.3ms
   CDelScale = 256/4096;	%85.3ms
   ADelScale = 256/528;		%10.67ms
   
	fid = fopen('COM1:','w');
	fprintf(1,'\n\n\n');

	for i = 1:ENum
	temp = sampdel(EDel(i));
      del = round(EDelScale * temp);
      fwrite(fid,del,'int8');
      coe = round(scale * ECoe(i));
      fwrite(fid,coe,'int8');
      fprintf(1,'\n%f %f\t%f %f\n',temp,del,ECoe(i),coe);
	end
   for i = 1:CNum
	temp = sampdel(CDel(i));
      del = round(CDelScale * temp);
      fwrite(fid,del,'int8');
      coec = round(scale * CCoeC(i));
       fwrite(fid,coec,'int8');
     coed = round(scale * CCoeD(i));
      fwrite(fid,coed,'int8');
      fprintf(1,'\n%f %f\t%f %f\t%f %f\n',
	temp,del,CCoeC(i),coec,CCoeD(i),coed);
	end
   for i = 1:ANum
	temp = sampdel(ADel(i));
      del = round(ADelScale * temp);
      fwrite(fid,del,'int8');
      fprintf(1,'\n%f %f\n',temp,del);
   end
   
   bri = round(scale*RBri);
   fwrite(fid,bri,'int8');
   mix = round(scale*RMix);
   fwrite(fid,mix,'int8');
   fprintf(1,'\n%f %f\t%f %f\n',RBri,bri,RMix,mix);

	fwrite(fid,255,'int8');		% RESET
	fprintf(1,'\n255\n');

	fclose(fid);

end

