function updateap(action,input);
%=============================
% Update All-pass filter parameters

global ANum ADel ADelMax ADelMin;
global ADelSlider ADelVal;

if strcmp(action,'setdel'),
	num = get(gco,'UserData');
	if (input == 1),		% slider input
		ADel(num) = get(gco,'value');
		set(ADelVal(num),'string',ADel(num));
	else				% text input
		temp = str2num(get(gco,'string'));
		if (temp > ADelMax) temp = ADelMax;
		elseif (temp < ADelMin) temp = ADelMin;
		end
		set(gco,'string',num2str(temp));
		set(ADelSlider(num),'value',temp);
		ADel(num) = temp;
	end

elseif strcmp(action,'start'),
	for i = 1:ANum
	left_pos = .535 + .155*(i-1);
	bottom_pos = .9;

ACaption=uicontrol('style','text',...
	'Units','normalized',...
	'pos',[left_pos+.01 bottom_pos+.02 .25 .05], ...
	'BackgroundColor','black','ForegroundColor','white',...
	'HorizontalAlignment','left',...
	'String',['Allpass Filter ' num2str(i)]);

ADelMinBox=uicontrol('style','text',...
   'Units','normalized','BackgroundColor','black',...
	'pos',[left_pos-.005 bottom_pos .03 .03 ],...
   'ForegroundColor','white','String',num2str(ADelMin));

ADelMaxBox=uicontrol('style','text',...
        'Units','normalized','BackgroundColor','black',...
	'pos',[left_pos+.115 bottom_pos .03 .03],...
        'ForegroundColor','white',...
	'String',num2str(ADelMax));

ADelSlider(i) = uicontrol( ...
	'Style','slider', ...
	'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos .1 .03], ...
	'Max',ADelMax, ...
	'Min',ADelMin, ...
	'Value',ADel(i), ...
	'UserData',i, ...
	'Callback','updateap(''setdel'',1);');

ADelVal(i)=uicontrol('Style','edit', ...
        'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos-.04 .1 .04],...
	'String',num2str(ADel(i)), ...
	'UserData',i, ...
	'Callback','updateap(''setdel'',2);');

	end

end

