function updatebm(action,input);
%=============================
% Update Brightness and Mix

global RMix RMixSlider RMixVal RMixMax RMixMin;
global RBri RBriSlider RBriVal RBriMax RBriMin;

if strcmp(action,'setBri')
	if (input == 1),		% slider input
		RBri = get(gco,'value');
		set(RBriVal,'string',RBri);
	else				% text input
		temp = str2num(get(gco,'string'));
		if (temp > RBriMax) temp = RBriMax;
		elseif (temp < RBriMin) temp = RBriMin;
		end
		set(gco,'string',num2str(temp));
		set(RBriSlider,'value',temp);
		RBri = temp;
	end

elseif strcmp(action,'setMix'),
	if (input == 1),		% slider input
		RMix = get(gco,'value');
		set(RMixVal,'string',RMix);
	else				% text input
		temp = str2num(get(gco,'string'));
		if (temp > RMixMax) temp = RMixMax;
		elseif (temp < RMixMin) temp = RMixMin;
		end
		set(gco,'string',num2str(temp));
		set(RMixSlider,'value',temp);
		RMix = temp;
	end

elseif strcmp(action,'start'),
	left_pos = .5;
	bottom_pos = .3;

RBriCaption=uicontrol('style','text',...
	'Units','normalized',...
	'pos',[left_pos+.01 bottom_pos+.02 .25 .05], ...
	'HorizontalAlignment','left',...
	'BackgroundColor','black','ForegroundColor','white',...
	'String','Brightness');

RBriMinBox=uicontrol('style','text',...
        'Units','normalized','BackgroundColor','black',...
	'pos',[left_pos-.01 bottom_pos-.02 .03 .05 ],...
        'ForegroundColor','white','String',num2str(RBriMin));

RBriMaxBox=uicontrol('style','text',...
        'Units','normalized','BackgroundColor','black',...
	'pos',[left_pos+.12 bottom_pos-.02 .03 .05],...
        'ForegroundColor','white',...
	'String',num2str(RBriMax));

RBriSlider = uicontrol( ...
	'Style','slider', ...
	'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos .1 .03], ...
	'Max',RBriMax, ...
	'Min',RBriMin, ...
	'Value',RBri, ...
	'UserData',i, ...
	'Callback','updatebm(''setBri'',1);');

RBriVal=uicontrol('Style','edit', ...
        'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos-.04 .1 .04],...
	'String',num2str(RBri), ...
	'UserData',i, ...
	'Callback','updatebm(''setBri'',2);');

	left_pos = .7;

RMixCaption=uicontrol('style','text',...
	'Units','normalized',...
	'pos',[left_pos+.01 bottom_pos+.02 .25 .05], ...
	'BackgroundColor','black','ForegroundColor','white',...
	'HorizontalAlignment','left',...
	'String','Reverberation Mix');

RMixMinBox=uicontrol('style','text',...
        'Units','normalized','BackgroundColor','black',...
	'pos',[left_pos-.01 bottom_pos-.02 .03 .05 ],...
        'ForegroundColor','white','String',num2str(RMixMin));

RMixMaxBox=uicontrol('style','text',...
        'Units','normalized','BackgroundColor','black',...
 	'pos',[left_pos+.12 bottom_pos-.02 .03 .05],...
       'ForegroundColor','white',...
	'String',num2str(RMixMax));

RMixSlider = uicontrol( ...
	'Style','slider', ...
	'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos .1 .03], ...
	'Max',RMixMax, ...
	'Min',RMixMin, ...
	'Value',RMix, ...
	'UserData',i, ...
	'Callback','updatebm(''setMix'',1);');

RMixVal=uicontrol('Style','edit', ...
        'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos-.04 .1 .04],...
	'String',num2str(RMix), ...
	'UserData',i, ...
	'Callback','updatebm(''setMix'',2);');

end

