function updateco(action,input);
%=============================
% Update Comb filter parameters

global CNum CTim CDam CDel CCoeL CCoeH CCoeD CCoeC;
global CTimSlider CTimVal CDamSlider CDamVal CDelSlider CDelVal;
global CCoeLBox CCoeHBox CCoeCBox CCoeDBox;
global CDelMax CDelMin CTimMax CTimMin CDamMax CDamMin;

if strcmp(action,'setdel'),
	num = get(gco,'UserData');
	if (input == 1),		% slider input
		CDel(num) = get(gco,'value');
		set(CDelVal(num),'string',CDel(num));
	else				% text input
		temp = str2num(get(gco,'string'));
		if (temp > CDelMax) temp = CDelMax;
		elseif (temp < CDelMin) temp = CDelMin;
		end
		set(gco,'string',num2str(temp));
		set(CDelSlider(num),'value',temp);
		CDel(num) = temp;
	end

elseif strcmp(action,'setTim'),
	if (input == 1),		% slider input
		CTim = get(gco,'value');
		set(CTimVal,'string',CTim);
	else				% text input
		temp = str2num(get(gco,'string'));
		if (temp > CTimMax) temp = CTimMax;
		elseif (temp < CTimMin) temp = CTimMin;
		end
		set(gco,'string',num2str(temp));
		set(CTimSlider,'value',temp);
		CTim = temp;
	end

elseif strcmp(action,'setDam'),
	if (input == 1),		% slider input
		CDam = get(gco,'value');
		set(CDamVal,'string',CDam);
	else				% text input
		temp = str2num(get(gco,'string'));
		if (temp > CDamMax) temp = CDamMax;
		elseif (temp < CDamMin) temp = CDamMin;
		end
		set(gco,'string',num2str(temp));
		set(CDamSlider,'value',temp);
		CDam = temp;
	end

elseif strcmp(action,'setcoec'),
	num = get(gco,'UserData');
	temp = str2num(get(gco,'string'));
	if (temp > 1) temp = 1;
	elseif (temp < 0) temp = 0;
	end
	set(gco,'string',num2str(temp));
	CCoeC(num) = temp;

elseif strcmp(action,'setcoed'),
	num = get(gco,'UserData');
	temp = str2num(get(gco,'string'));
	if (temp > 1) temp = 1;
	elseif (temp < 0) temp = 0;
	end
	set(gco,'string',num2str(temp));
	CCoeD(num) = temp;

elseif strcmp(action,'start'),
   
   bottom_pos = .65;

CDelCaption=uicontrol('style','text',...
	'Units','normalized','pos',[.01 bottom_pos-.05 .08 .05],...
	'BackgroundColor','black','ForegroundColor','white',...
	'HorizontalAlignment','left',...
	'String','Delay (ms)');

CCoeLCaption=uicontrol('style','text',...
	'Units','normalized','pos',[.01 bottom_pos-.11 .08 .05],...
	'BackgroundColor','black','ForegroundColor','white',...
	'HorizontalAlignment','left',...
	'String','Low Gain');

CCoeHCaption=uicontrol('style','text',...
	'Units','normalized','pos',[.01 bottom_pos-.16 .08 .05],...
	'BackgroundColor','black','ForegroundColor','white',...
	'HorizontalAlignment','left',...
	'String','High Gain');

CCoeCCaption=uicontrol('style','text',...
	'Units','normalized','pos',[.01 bottom_pos-.21 .08 .05],...
	'BackgroundColor','black','ForegroundColor','white',...
	'HorizontalAlignment','left',...
	'String','Loop Gain');

CCoeDCaption=uicontrol('style','text',...
	'Units','normalized','pos',[.01 bottom_pos-.26 .08 .05],...
	'BackgroundColor','black','ForegroundColor','white',...
	'HorizontalAlignment','left',...
	'String','Damp Gain');

	for i = 1:CNum
		delay = CDel(i) * .001 / CTim;
		CCoeL(i) = 0.001^delay;
		CCoeH(i) = 0.001^(delay * CDam);
		CCoeD(i) = (CCoeL(i) - CCoeH(i)) / (CCoeL(i) + CCoeH(i));
      CCoeC(i) = (1. - CCoeD(i) ) * CCoeL(i);

		left_pos = .07 + .155*(i-1);

CCaption=uicontrol('style','text',...
	'Units','normalized',...
	'pos',[left_pos+.01 bottom_pos+.02 .25 .05], ...
	'BackgroundColor','black','ForegroundColor','white',...
	'HorizontalAlignment','left',...
	'String',['Comb Filter ' num2str(i)]);

CDelMinBox=uicontrol('style','text',...
        'Units','normalized','BackgroundColor','black',...
 	'pos',[left_pos-.01 bottom_pos .03 .03 ],...
       'ForegroundColor','white','String',num2str(CDelMin));

CDelMaxBox=uicontrol('style','text',...
        'Units','normalized','BackgroundColor','black',...
	'pos',[left_pos+.115 bottom_pos .03 .03],...
        'ForegroundColor','white',...
	'String',num2str(CDelMax));

CDelSlider(i) = uicontrol( ...
	'Style','slider', ...
	'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos .1 .03], ...
	'Max',CDelMax, ...
	'Min',CDelMin, ...
	'Value',CDel(i), ...
	'UserData',i, ...
	'Callback','updateco(''setdel'',1);');

CDelVal(i)=uicontrol('Style','edit', ...
        'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos-.04 .1 .04],...
	'String',num2str(CDel(i)), ...
	'UserData',i, ...
	'Callback','updateco(''setdel'',2);');

CCoeLBox(i) = uicontrol('Style','edit', ...
        'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos-.09 .1 .04],...
	'String',num2str(CCoeL(i)));

CCoeHBox(i) = uicontrol('Style','edit', ...
        'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos-.14 .1 .04],...
	'String',num2str(CCoeH(i)));

CCoeCBox(i) = uicontrol('Style','edit', ...
        'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos-.19 .1 .04],...
	'String',num2str(CCoeC(i)), ...
	'UserData',i, ...
	'Callback','updateco(''setcoec'',1);');

CCoeDBox(i) = uicontrol('Style','edit', ...
        'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos-.24 .1 .04],...
	'String',num2str(CCoeD(i)), ...
	'UserData',i, ...
	'Callback','updateco(''setcoed'',1);');

	end

	bottom_pos = .3;
	left_pos = .1;

CTimCaption=uicontrol('style','text',...
	'Units','normalized',...
	'pos',[left_pos+.01 bottom_pos+.02 .25 .05], ...
	'BackgroundColor','black','ForegroundColor','white',...
	'HorizontalAlignment','left',...
	'String','Reverberation Time');

CTimMinBox=uicontrol('style','text',...
        'Units','normalized','BackgroundColor','black',...
	'pos',[left_pos-.01 bottom_pos-.02 .03 .05 ],...
        'ForegroundColor','white','String',num2str(CTimMin));

CTimMaxBox=uicontrol('style','text',...
        'Units','normalized','BackgroundColor','black',...
	'pos',[left_pos+.12 bottom_pos-.02 .03 .05],...
        'ForegroundColor','white',...
	'String',num2str(CTimMax));

CTimSlider = uicontrol( ...
	'Style','slider', ...
	'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos .1 .03], ...
	'Max',CTimMax, ...
	'Min',CTimMin, ...
	'Value',CTim, ...
	'UserData',i, ...
	'Callback','updateco(''setTim'',1);');

CTimVal=uicontrol('Style','edit', ...
        'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos-.04 .1 .04],...
	'String',num2str(CTim), ...
	'UserData',i, ...
	'Callback','updateco(''setTim'',2);');

	left_pos = .3;

CDamCaption=uicontrol('style','text',...
	'Units','normalized',...
	'pos',[left_pos+.01 bottom_pos+.02 .25 .05], ...
	'BackgroundColor','black','ForegroundColor','white',...
	'HorizontalAlignment','left',...
	'String','High-freq Damping');

CDamMinBox=uicontrol('style','text',...
        'Units','normalized','BackgroundColor','black',...
 	'pos',[left_pos bottom_pos-.02 .03 .05 ],...
       'ForegroundColor','white','String',num2str(CDamMin));

CDamMaxBox=uicontrol('style','text',...
        'Units','normalized','BackgroundColor','black',...
	'pos',[left_pos+.12 bottom_pos-.02 .03 .05],...
        'ForegroundColor','white',...
	'String',num2str(CDamMax));

CDamSlider = uicontrol( ...
	'Style','slider', ...
	'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos .1 .03], ...
	'Max',CDamMax, ...
	'Min',CDamMin, ...
	'Value',CDam, ...
	'UserData',i, ...
	'Callback','updateco(''setDam'',1);');

CDamVal=uicontrol('Style','edit', ...
        'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos-.04 .1 .04],...
	'String',num2str(CDam), ...
	'UserData',i, ...
	'Callback','updateco(''setDam'',2);');

end

if (strcmp(action,'setcoec') + strcmp(action,'setcoed') ==0),
for i = 1:CNum
	delay = CDel(i) * .001 / CTim;
	CCoeL(i) = 0.001^delay;
	CCoeH(i) = 0.001^(delay * CDam);
	CCoeD(i) = (CCoeL(i) - CCoeH(i)) / (CCoeL(i) + CCoeH(i));
   CCoeC(i) = (1. - CCoeD(i) ) * CCoeL(i);
	set(CCoeLBox(i),'string',num2str(CCoeL(i)));
	set(CCoeHBox(i),'string',num2str(CCoeH(i)));
	set(CCoeCBox(i),'string',num2str(CCoeC(i)));
	set(CCoeDBox(i),'string',num2str(CCoeD(i)));
end
end

