function updateer(action,input);
%=============================
% Update Early Reflection parameters

global ENum EDel ECoe EDelSlider ECoeSlider EDelVal ECoeVal;
global EDelMax EDelMin ECoeMax ECoeMin;

if strcmp(action,'setdel'),
	num = get(gco,'UserData');
	if (input == 1),		% slider input
		EDel(num) = get(gco,'value');
		set(EDelVal(num),'string',EDel(num));
	else				% text input
		temp = str2num(get(gco,'string'));
		if (temp > EDelMax) temp = EDelMax;
		elseif (temp < EDelMin) temp = EDelMin;
		end
		set(gco,'string',num2str(temp));
		set(EDelSlider(num),'value',temp);
		EDel(num) = temp;
	end

elseif strcmp(action,'setcoe'),
	num = get(gco,'UserData');
	if (input == 1),		% slider input
		ECoe(num) = get(gco,'value');
		set(ECoeVal(num),'string',ECoe(num));
	else				% text input
		temp = str2num(get(gco,'string'));
		if (temp > ECoeMax) temp = ECoeMax;
		elseif (temp < ECoeMin) temp = ECoeMin;
		end
		set(gco,'string',num2str(temp));
		set(ECoeSlider(num),'value',temp);
		ECoe(num) = temp;
	end

elseif strcmp(action,'start'),

	bottom_pos = .9;

EDelCaption=uicontrol('style','text',...
	'BackgroundColor','black','ForegroundColor','white',...
	'Units','normalized','pos',[.01 bottom_pos-.05 .1 .05],...
	'HorizontalAlignment','left',...
	'String','Delay (ms)');

ECoeCaption=uicontrol('style','text',...
	'BackgroundColor','black','ForegroundColor','white',...
	'Units','normalized','pos',[.01 bottom_pos-.15 .1 .05],...
	'HorizontalAlignment','left',...
	'String','Gain');

	for i = 1:ENum
	left_pos = .07 + .155*(i-1);

ECaption=uicontrol('style','text',...
	'Units','normalized',...
	'pos',[left_pos+.01 bottom_pos+.02 .25 .05], ...
	'BackgroundColor','black','ForegroundColor','white',...
	'HorizontalAlignment','left',...
	'String',['Early Reflection ' num2str(i)]);

EDelMinBox=uicontrol('style','text',...
        'Units','normalized','BackgroundColor','black',...
	'pos',[left_pos-.01 bottom_pos .03 .03 ],...
        'ForegroundColor','white','String',num2str(EDelMin));

EDelMaxBox=uicontrol('style','text',...
        'Units','normalized','BackgroundColor','black',...
	'pos',[left_pos+.115 bottom_pos .03 .03],...
        'ForegroundColor','white',...
	'String',num2str(EDelMax));

EDelSlider(i) = uicontrol( ...
	'Style','slider', ...
	'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos .1 .03], ...
	'Max',EDelMax, ...
	'Min',EDelMin, ...
	'Value',EDel(i), ...
	'UserData',i, ...
	'Callback','updateer(''setdel'',1);');

EDelVal(i)=uicontrol('Style','edit', ...
        'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos-.04 .1 .04],...
	'String',num2str(EDel(i)), ...
	'UserData',i, ...
	'Callback','updateer(''setdel'',2);');

ECoeMinBox=uicontrol('style','text',...
        'Units','normalized','BackgroundColor','black',...
	'pos',[left_pos-.01 bottom_pos-.12 .03 .05 ],...
        'ForegroundColor','white','String',num2str(ECoeMin));

ECoeMaxBox=uicontrol('style','text',...
        'Units','normalized','BackgroundColor','black',...
 	'pos',[left_pos+.12 bottom_pos-.12 .03 .05],...
       'ForegroundColor','white','String',num2str(ECoeMax));

ECoeSlider(i) = uicontrol( ...
	'Style','slider', ...
	'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos-.1 .1 .03], ...
	'Max',ECoeMax, ...
	'Min',ECoeMin, ...
	'Value',ECoe(i), ...
	'UserData',i, ...
	'Callback','updateer(''setcoe'',1);');

ECoeVal(i)=uicontrol('Style','edit', ...
        'Units','normalized', ...
	'Position',[left_pos+.02 bottom_pos-.14 .1 .04],...
	'String',num2str(ECoe(i)), ...
	'UserData',i, ...
	'Callback','updateer(''setcoe'',2);');

	end

end

